\begin{algorithm}
\caption{RLNC Dissemination Procedures\label{algo3}}
\begin{algorithmic}[1]
  \State $ts\gets ...$ \Comment{Trading size}
  \State $sm\gets ...$ \Comment{Safety margin}
  \State $g\gets 0$ \Comment{Encoding generation}
  \State $rcv\gets \Call{Set}$ \Comment{Received packets}
  \State $ids\gets \Call{OrderedSet}$ \Comment{Received message identifiers}
  \State $dlv\gets \Call{OrderedSet}$ \Comment{Delivered message identifiers}
  \item[]

  \Function{NextGen}{h}
    \If{$h > g \lor \Call{Rank}{g,rcv} \geq 1$}
      \State $g \gets \Call{max}{h, g} + 1$
    \EndIf
  \EndFunction
  \item[]

  \Function{ProcessPacket}{p}
    \If{$p = \varnothing$}
      \State \Return False
    \EndIf

    \State $ \langle g_1, c_1, \_ \rangle \gets p$
    \State $ oldRank \gets \Call{Rank}{g_1, rcv}$
    \State $rcv \gets \Call{Solve}{g_1, rcv \cup \{ p \}} $ \label{line:decode}
    \item[]
    \If{$oldRank = \Call{Rank}{g_1, rcv}$}
      \State \Return False \Comment Packet was useless
    \item[]
    \EndIf %\Comment New information in the matrix
    \ForAll{$ \langle msg_{id}, \_ \rangle \in c_1 $}
      \State $ids \gets ids \cup \{ msg_{id} \}$
    \EndFor
    \ForAll{$\langle g_2, c_2, e \rangle \in rcv$}
      \If{$g_1 = g_2 \land \Call{len}{c_2} = 1 \land c_2[0].first \notin dlv $}
        \State $dlv \gets dlv \cup \{ c_2[0].first \}$
        \State $\Call{Deliver}{e}$
      \EndIf
    \EndFor
    \State $\Call{NextGen}{g_1}$
    \State \Return True \Comment Packet was useful
  \EndFunction
  \item[]

  \Function{GetTradingWindow}{}
    \State $start \gets \Call{max}{0,|ids| - sm - tm}$
    \State $end \gets \Call{max}{0, |ids|  - sm}$
    \State \Return $ids[start:end]$
  \EndFunction

\end{algorithmic}
\end{algorithm}


